=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class ComAdobeCqSocialMessagingClientEndpointsImplMessagingOperationProperties
    attr_accessor :message_properties

    attr_accessor :message_box_size_limit

    attr_accessor :message_count_limit

    attr_accessor :notify_failure

    attr_accessor :failure_message_from

    attr_accessor :failure_template_path

    attr_accessor :max_retries

    attr_accessor :min_wait_between_retries

    attr_accessor :count_update_pool_size

    attr_accessor :inbox_path

    attr_accessor :sentitems_path

    attr_accessor :support_attachments

    attr_accessor :support_group_messaging

    attr_accessor :max_total_recipients

    attr_accessor :batch_size

    attr_accessor :max_total_attachment_size

    attr_accessor :attachment_type_blacklist

    attr_accessor :allowed_attachment_types

    attr_accessor :service_selector

    attr_accessor :field_whitelist

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'message_properties' => :'message.properties',
        :'message_box_size_limit' => :'messageBoxSizeLimit',
        :'message_count_limit' => :'messageCountLimit',
        :'notify_failure' => :'notifyFailure',
        :'failure_message_from' => :'failureMessageFrom',
        :'failure_template_path' => :'failureTemplatePath',
        :'max_retries' => :'maxRetries',
        :'min_wait_between_retries' => :'minWaitBetweenRetries',
        :'count_update_pool_size' => :'countUpdatePoolSize',
        :'inbox_path' => :'inbox.path',
        :'sentitems_path' => :'sentitems.path',
        :'support_attachments' => :'supportAttachments',
        :'support_group_messaging' => :'supportGroupMessaging',
        :'max_total_recipients' => :'maxTotalRecipients',
        :'batch_size' => :'batchSize',
        :'max_total_attachment_size' => :'maxTotalAttachmentSize',
        :'attachment_type_blacklist' => :'attachmentTypeBlacklist',
        :'allowed_attachment_types' => :'allowedAttachmentTypes',
        :'service_selector' => :'serviceSelector',
        :'field_whitelist' => :'fieldWhitelist'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'message_properties' => :'ConfigNodePropertyArray',
        :'message_box_size_limit' => :'ConfigNodePropertyInteger',
        :'message_count_limit' => :'ConfigNodePropertyInteger',
        :'notify_failure' => :'ConfigNodePropertyBoolean',
        :'failure_message_from' => :'ConfigNodePropertyString',
        :'failure_template_path' => :'ConfigNodePropertyString',
        :'max_retries' => :'ConfigNodePropertyInteger',
        :'min_wait_between_retries' => :'ConfigNodePropertyInteger',
        :'count_update_pool_size' => :'ConfigNodePropertyInteger',
        :'inbox_path' => :'ConfigNodePropertyString',
        :'sentitems_path' => :'ConfigNodePropertyString',
        :'support_attachments' => :'ConfigNodePropertyBoolean',
        :'support_group_messaging' => :'ConfigNodePropertyBoolean',
        :'max_total_recipients' => :'ConfigNodePropertyInteger',
        :'batch_size' => :'ConfigNodePropertyInteger',
        :'max_total_attachment_size' => :'ConfigNodePropertyInteger',
        :'attachment_type_blacklist' => :'ConfigNodePropertyArray',
        :'allowed_attachment_types' => :'ConfigNodePropertyArray',
        :'service_selector' => :'ConfigNodePropertyString',
        :'field_whitelist' => :'ConfigNodePropertyArray'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'message.properties')
        self.message_properties = attributes[:'message.properties']
      end

      if attributes.has_key?(:'messageBoxSizeLimit')
        self.message_box_size_limit = attributes[:'messageBoxSizeLimit']
      end

      if attributes.has_key?(:'messageCountLimit')
        self.message_count_limit = attributes[:'messageCountLimit']
      end

      if attributes.has_key?(:'notifyFailure')
        self.notify_failure = attributes[:'notifyFailure']
      end

      if attributes.has_key?(:'failureMessageFrom')
        self.failure_message_from = attributes[:'failureMessageFrom']
      end

      if attributes.has_key?(:'failureTemplatePath')
        self.failure_template_path = attributes[:'failureTemplatePath']
      end

      if attributes.has_key?(:'maxRetries')
        self.max_retries = attributes[:'maxRetries']
      end

      if attributes.has_key?(:'minWaitBetweenRetries')
        self.min_wait_between_retries = attributes[:'minWaitBetweenRetries']
      end

      if attributes.has_key?(:'countUpdatePoolSize')
        self.count_update_pool_size = attributes[:'countUpdatePoolSize']
      end

      if attributes.has_key?(:'inbox.path')
        self.inbox_path = attributes[:'inbox.path']
      end

      if attributes.has_key?(:'sentitems.path')
        self.sentitems_path = attributes[:'sentitems.path']
      end

      if attributes.has_key?(:'supportAttachments')
        self.support_attachments = attributes[:'supportAttachments']
      end

      if attributes.has_key?(:'supportGroupMessaging')
        self.support_group_messaging = attributes[:'supportGroupMessaging']
      end

      if attributes.has_key?(:'maxTotalRecipients')
        self.max_total_recipients = attributes[:'maxTotalRecipients']
      end

      if attributes.has_key?(:'batchSize')
        self.batch_size = attributes[:'batchSize']
      end

      if attributes.has_key?(:'maxTotalAttachmentSize')
        self.max_total_attachment_size = attributes[:'maxTotalAttachmentSize']
      end

      if attributes.has_key?(:'attachmentTypeBlacklist')
        self.attachment_type_blacklist = attributes[:'attachmentTypeBlacklist']
      end

      if attributes.has_key?(:'allowedAttachmentTypes')
        self.allowed_attachment_types = attributes[:'allowedAttachmentTypes']
      end

      if attributes.has_key?(:'serviceSelector')
        self.service_selector = attributes[:'serviceSelector']
      end

      if attributes.has_key?(:'fieldWhitelist')
        self.field_whitelist = attributes[:'fieldWhitelist']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          message_properties == o.message_properties &&
          message_box_size_limit == o.message_box_size_limit &&
          message_count_limit == o.message_count_limit &&
          notify_failure == o.notify_failure &&
          failure_message_from == o.failure_message_from &&
          failure_template_path == o.failure_template_path &&
          max_retries == o.max_retries &&
          min_wait_between_retries == o.min_wait_between_retries &&
          count_update_pool_size == o.count_update_pool_size &&
          inbox_path == o.inbox_path &&
          sentitems_path == o.sentitems_path &&
          support_attachments == o.support_attachments &&
          support_group_messaging == o.support_group_messaging &&
          max_total_recipients == o.max_total_recipients &&
          batch_size == o.batch_size &&
          max_total_attachment_size == o.max_total_attachment_size &&
          attachment_type_blacklist == o.attachment_type_blacklist &&
          allowed_attachment_types == o.allowed_attachment_types &&
          service_selector == o.service_selector &&
          field_whitelist == o.field_whitelist
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [message_properties, message_box_size_limit, message_count_limit, notify_failure, failure_message_from, failure_template_path, max_retries, min_wait_between_retries, count_update_pool_size, inbox_path, sentitems_path, support_attachments, support_group_messaging, max_total_recipients, batch_size, max_total_attachment_size, attachment_type_blacklist, allowed_attachment_types, service_selector, field_whitelist].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
