=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class ComAdobeGraniteAuthOauthProviderProperties
    attr_accessor :oauth_config_id

    attr_accessor :oauth_client_id

    attr_accessor :oauth_client_secret

    attr_accessor :oauth_scope

    attr_accessor :oauth_config_provider_id

    attr_accessor :oauth_create_users

    attr_accessor :oauth_userid_property

    attr_accessor :force_strict_username_matching

    attr_accessor :oauth_encode_userids

    attr_accessor :oauth_hash_userids

    attr_accessor :oauth_call_back_url

    attr_accessor :oauth_access_token_persist

    attr_accessor :oauth_access_token_persist_cookie

    attr_accessor :oauth_csrf_state_protection

    attr_accessor :oauth_redirect_request_params

    attr_accessor :oauth_config_siblings_allow

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'oauth_config_id' => :'oauth.config.id',
        :'oauth_client_id' => :'oauth.client.id',
        :'oauth_client_secret' => :'oauth.client.secret',
        :'oauth_scope' => :'oauth.scope',
        :'oauth_config_provider_id' => :'oauth.config.provider.id',
        :'oauth_create_users' => :'oauth.create.users',
        :'oauth_userid_property' => :'oauth.userid.property',
        :'force_strict_username_matching' => :'force.strict.username.matching',
        :'oauth_encode_userids' => :'oauth.encode.userids',
        :'oauth_hash_userids' => :'oauth.hash.userids',
        :'oauth_call_back_url' => :'oauth.callBackUrl',
        :'oauth_access_token_persist' => :'oauth.access.token.persist',
        :'oauth_access_token_persist_cookie' => :'oauth.access.token.persist.cookie',
        :'oauth_csrf_state_protection' => :'oauth.csrf.state.protection',
        :'oauth_redirect_request_params' => :'oauth.redirect.request.params',
        :'oauth_config_siblings_allow' => :'oauth.config.siblings.allow'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'oauth_config_id' => :'ConfigNodePropertyString',
        :'oauth_client_id' => :'ConfigNodePropertyString',
        :'oauth_client_secret' => :'ConfigNodePropertyString',
        :'oauth_scope' => :'ConfigNodePropertyArray',
        :'oauth_config_provider_id' => :'ConfigNodePropertyString',
        :'oauth_create_users' => :'ConfigNodePropertyBoolean',
        :'oauth_userid_property' => :'ConfigNodePropertyString',
        :'force_strict_username_matching' => :'ConfigNodePropertyBoolean',
        :'oauth_encode_userids' => :'ConfigNodePropertyBoolean',
        :'oauth_hash_userids' => :'ConfigNodePropertyBoolean',
        :'oauth_call_back_url' => :'ConfigNodePropertyString',
        :'oauth_access_token_persist' => :'ConfigNodePropertyBoolean',
        :'oauth_access_token_persist_cookie' => :'ConfigNodePropertyBoolean',
        :'oauth_csrf_state_protection' => :'ConfigNodePropertyBoolean',
        :'oauth_redirect_request_params' => :'ConfigNodePropertyBoolean',
        :'oauth_config_siblings_allow' => :'ConfigNodePropertyBoolean'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'oauth.config.id')
        self.oauth_config_id = attributes[:'oauth.config.id']
      end

      if attributes.has_key?(:'oauth.client.id')
        self.oauth_client_id = attributes[:'oauth.client.id']
      end

      if attributes.has_key?(:'oauth.client.secret')
        self.oauth_client_secret = attributes[:'oauth.client.secret']
      end

      if attributes.has_key?(:'oauth.scope')
        self.oauth_scope = attributes[:'oauth.scope']
      end

      if attributes.has_key?(:'oauth.config.provider.id')
        self.oauth_config_provider_id = attributes[:'oauth.config.provider.id']
      end

      if attributes.has_key?(:'oauth.create.users')
        self.oauth_create_users = attributes[:'oauth.create.users']
      end

      if attributes.has_key?(:'oauth.userid.property')
        self.oauth_userid_property = attributes[:'oauth.userid.property']
      end

      if attributes.has_key?(:'force.strict.username.matching')
        self.force_strict_username_matching = attributes[:'force.strict.username.matching']
      end

      if attributes.has_key?(:'oauth.encode.userids')
        self.oauth_encode_userids = attributes[:'oauth.encode.userids']
      end

      if attributes.has_key?(:'oauth.hash.userids')
        self.oauth_hash_userids = attributes[:'oauth.hash.userids']
      end

      if attributes.has_key?(:'oauth.callBackUrl')
        self.oauth_call_back_url = attributes[:'oauth.callBackUrl']
      end

      if attributes.has_key?(:'oauth.access.token.persist')
        self.oauth_access_token_persist = attributes[:'oauth.access.token.persist']
      end

      if attributes.has_key?(:'oauth.access.token.persist.cookie')
        self.oauth_access_token_persist_cookie = attributes[:'oauth.access.token.persist.cookie']
      end

      if attributes.has_key?(:'oauth.csrf.state.protection')
        self.oauth_csrf_state_protection = attributes[:'oauth.csrf.state.protection']
      end

      if attributes.has_key?(:'oauth.redirect.request.params')
        self.oauth_redirect_request_params = attributes[:'oauth.redirect.request.params']
      end

      if attributes.has_key?(:'oauth.config.siblings.allow')
        self.oauth_config_siblings_allow = attributes[:'oauth.config.siblings.allow']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          oauth_config_id == o.oauth_config_id &&
          oauth_client_id == o.oauth_client_id &&
          oauth_client_secret == o.oauth_client_secret &&
          oauth_scope == o.oauth_scope &&
          oauth_config_provider_id == o.oauth_config_provider_id &&
          oauth_create_users == o.oauth_create_users &&
          oauth_userid_property == o.oauth_userid_property &&
          force_strict_username_matching == o.force_strict_username_matching &&
          oauth_encode_userids == o.oauth_encode_userids &&
          oauth_hash_userids == o.oauth_hash_userids &&
          oauth_call_back_url == o.oauth_call_back_url &&
          oauth_access_token_persist == o.oauth_access_token_persist &&
          oauth_access_token_persist_cookie == o.oauth_access_token_persist_cookie &&
          oauth_csrf_state_protection == o.oauth_csrf_state_protection &&
          oauth_redirect_request_params == o.oauth_redirect_request_params &&
          oauth_config_siblings_allow == o.oauth_config_siblings_allow
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [oauth_config_id, oauth_client_id, oauth_client_secret, oauth_scope, oauth_config_provider_id, oauth_create_users, oauth_userid_property, force_strict_username_matching, oauth_encode_userids, oauth_hash_userids, oauth_call_back_url, oauth_access_token_persist, oauth_access_token_persist_cookie, oauth_csrf_state_protection, oauth_redirect_request_params, oauth_config_siblings_allow].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
