=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class ComAdobeGraniteThreaddumpThreadDumpCollectorProperties
    attr_accessor :scheduler_period

    attr_accessor :scheduler_run_on

    attr_accessor :granite_threaddump_enabled

    attr_accessor :granite_threaddump_dumps_per_file

    attr_accessor :granite_threaddump_enable_gzip_compression

    attr_accessor :granite_threaddump_enable_directories_compression

    attr_accessor :granite_threaddump_enable_j_stack

    attr_accessor :granite_threaddump_max_backup_days

    attr_accessor :granite_threaddump_backup_clean_trigger

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'scheduler_period' => :'scheduler.period',
        :'scheduler_run_on' => :'scheduler.runOn',
        :'granite_threaddump_enabled' => :'granite.threaddump.enabled',
        :'granite_threaddump_dumps_per_file' => :'granite.threaddump.dumpsPerFile',
        :'granite_threaddump_enable_gzip_compression' => :'granite.threaddump.enableGzipCompression',
        :'granite_threaddump_enable_directories_compression' => :'granite.threaddump.enableDirectoriesCompression',
        :'granite_threaddump_enable_j_stack' => :'granite.threaddump.enableJStack',
        :'granite_threaddump_max_backup_days' => :'granite.threaddump.maxBackupDays',
        :'granite_threaddump_backup_clean_trigger' => :'granite.threaddump.backupCleanTrigger'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'scheduler_period' => :'ConfigNodePropertyInteger',
        :'scheduler_run_on' => :'ConfigNodePropertyDropDown',
        :'granite_threaddump_enabled' => :'ConfigNodePropertyBoolean',
        :'granite_threaddump_dumps_per_file' => :'ConfigNodePropertyInteger',
        :'granite_threaddump_enable_gzip_compression' => :'ConfigNodePropertyBoolean',
        :'granite_threaddump_enable_directories_compression' => :'ConfigNodePropertyBoolean',
        :'granite_threaddump_enable_j_stack' => :'ConfigNodePropertyBoolean',
        :'granite_threaddump_max_backup_days' => :'ConfigNodePropertyInteger',
        :'granite_threaddump_backup_clean_trigger' => :'ConfigNodePropertyString'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'scheduler.period')
        self.scheduler_period = attributes[:'scheduler.period']
      end

      if attributes.has_key?(:'scheduler.runOn')
        self.scheduler_run_on = attributes[:'scheduler.runOn']
      end

      if attributes.has_key?(:'granite.threaddump.enabled')
        self.granite_threaddump_enabled = attributes[:'granite.threaddump.enabled']
      end

      if attributes.has_key?(:'granite.threaddump.dumpsPerFile')
        self.granite_threaddump_dumps_per_file = attributes[:'granite.threaddump.dumpsPerFile']
      end

      if attributes.has_key?(:'granite.threaddump.enableGzipCompression')
        self.granite_threaddump_enable_gzip_compression = attributes[:'granite.threaddump.enableGzipCompression']
      end

      if attributes.has_key?(:'granite.threaddump.enableDirectoriesCompression')
        self.granite_threaddump_enable_directories_compression = attributes[:'granite.threaddump.enableDirectoriesCompression']
      end

      if attributes.has_key?(:'granite.threaddump.enableJStack')
        self.granite_threaddump_enable_j_stack = attributes[:'granite.threaddump.enableJStack']
      end

      if attributes.has_key?(:'granite.threaddump.maxBackupDays')
        self.granite_threaddump_max_backup_days = attributes[:'granite.threaddump.maxBackupDays']
      end

      if attributes.has_key?(:'granite.threaddump.backupCleanTrigger')
        self.granite_threaddump_backup_clean_trigger = attributes[:'granite.threaddump.backupCleanTrigger']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          scheduler_period == o.scheduler_period &&
          scheduler_run_on == o.scheduler_run_on &&
          granite_threaddump_enabled == o.granite_threaddump_enabled &&
          granite_threaddump_dumps_per_file == o.granite_threaddump_dumps_per_file &&
          granite_threaddump_enable_gzip_compression == o.granite_threaddump_enable_gzip_compression &&
          granite_threaddump_enable_directories_compression == o.granite_threaddump_enable_directories_compression &&
          granite_threaddump_enable_j_stack == o.granite_threaddump_enable_j_stack &&
          granite_threaddump_max_backup_days == o.granite_threaddump_max_backup_days &&
          granite_threaddump_backup_clean_trigger == o.granite_threaddump_backup_clean_trigger
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [scheduler_period, scheduler_run_on, granite_threaddump_enabled, granite_threaddump_dumps_per_file, granite_threaddump_enable_gzip_compression, granite_threaddump_enable_directories_compression, granite_threaddump_enable_j_stack, granite_threaddump_max_backup_days, granite_threaddump_backup_clean_trigger].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
