=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class ComAdobeGraniteWorkflowCoreWorkflowSessionFactoryProperties
    attr_accessor :granite_workflowinbox_sort_property_name

    attr_accessor :granite_workflowinbox_sort_order

    attr_accessor :cq_workflow_job_retry

    attr_accessor :cq_workflow_superuser

    attr_accessor :granite_workflow_inbox_query_size

    attr_accessor :granite_workflow_admin_user_group_filter

    attr_accessor :granite_workflow_enforce_workitem_assignee_permissions

    attr_accessor :granite_workflow_enforce_workflow_initiator_permissions

    attr_accessor :granite_workflow_inject_tenant_id_in_job_topics

    attr_accessor :granite_workflow_max_purge_save_threshold

    attr_accessor :granite_workflow_max_purge_query_count

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'granite_workflowinbox_sort_property_name' => :'granite.workflowinbox.sort.propertyName',
        :'granite_workflowinbox_sort_order' => :'granite.workflowinbox.sort.order',
        :'cq_workflow_job_retry' => :'cq.workflow.job.retry',
        :'cq_workflow_superuser' => :'cq.workflow.superuser',
        :'granite_workflow_inbox_query_size' => :'granite.workflow.inboxQuerySize',
        :'granite_workflow_admin_user_group_filter' => :'granite.workflow.adminUserGroupFilter',
        :'granite_workflow_enforce_workitem_assignee_permissions' => :'granite.workflow.enforceWorkitemAssigneePermissions',
        :'granite_workflow_enforce_workflow_initiator_permissions' => :'granite.workflow.enforceWorkflowInitiatorPermissions',
        :'granite_workflow_inject_tenant_id_in_job_topics' => :'granite.workflow.injectTenantIdInJobTopics',
        :'granite_workflow_max_purge_save_threshold' => :'granite.workflow.maxPurgeSaveThreshold',
        :'granite_workflow_max_purge_query_count' => :'granite.workflow.maxPurgeQueryCount'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'granite_workflowinbox_sort_property_name' => :'ConfigNodePropertyDropDown',
        :'granite_workflowinbox_sort_order' => :'ConfigNodePropertyString',
        :'cq_workflow_job_retry' => :'ConfigNodePropertyInteger',
        :'cq_workflow_superuser' => :'ConfigNodePropertyArray',
        :'granite_workflow_inbox_query_size' => :'ConfigNodePropertyInteger',
        :'granite_workflow_admin_user_group_filter' => :'ConfigNodePropertyBoolean',
        :'granite_workflow_enforce_workitem_assignee_permissions' => :'ConfigNodePropertyBoolean',
        :'granite_workflow_enforce_workflow_initiator_permissions' => :'ConfigNodePropertyBoolean',
        :'granite_workflow_inject_tenant_id_in_job_topics' => :'ConfigNodePropertyBoolean',
        :'granite_workflow_max_purge_save_threshold' => :'ConfigNodePropertyInteger',
        :'granite_workflow_max_purge_query_count' => :'ConfigNodePropertyInteger'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'granite.workflowinbox.sort.propertyName')
        self.granite_workflowinbox_sort_property_name = attributes[:'granite.workflowinbox.sort.propertyName']
      end

      if attributes.has_key?(:'granite.workflowinbox.sort.order')
        self.granite_workflowinbox_sort_order = attributes[:'granite.workflowinbox.sort.order']
      end

      if attributes.has_key?(:'cq.workflow.job.retry')
        self.cq_workflow_job_retry = attributes[:'cq.workflow.job.retry']
      end

      if attributes.has_key?(:'cq.workflow.superuser')
        self.cq_workflow_superuser = attributes[:'cq.workflow.superuser']
      end

      if attributes.has_key?(:'granite.workflow.inboxQuerySize')
        self.granite_workflow_inbox_query_size = attributes[:'granite.workflow.inboxQuerySize']
      end

      if attributes.has_key?(:'granite.workflow.adminUserGroupFilter')
        self.granite_workflow_admin_user_group_filter = attributes[:'granite.workflow.adminUserGroupFilter']
      end

      if attributes.has_key?(:'granite.workflow.enforceWorkitemAssigneePermissions')
        self.granite_workflow_enforce_workitem_assignee_permissions = attributes[:'granite.workflow.enforceWorkitemAssigneePermissions']
      end

      if attributes.has_key?(:'granite.workflow.enforceWorkflowInitiatorPermissions')
        self.granite_workflow_enforce_workflow_initiator_permissions = attributes[:'granite.workflow.enforceWorkflowInitiatorPermissions']
      end

      if attributes.has_key?(:'granite.workflow.injectTenantIdInJobTopics')
        self.granite_workflow_inject_tenant_id_in_job_topics = attributes[:'granite.workflow.injectTenantIdInJobTopics']
      end

      if attributes.has_key?(:'granite.workflow.maxPurgeSaveThreshold')
        self.granite_workflow_max_purge_save_threshold = attributes[:'granite.workflow.maxPurgeSaveThreshold']
      end

      if attributes.has_key?(:'granite.workflow.maxPurgeQueryCount')
        self.granite_workflow_max_purge_query_count = attributes[:'granite.workflow.maxPurgeQueryCount']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          granite_workflowinbox_sort_property_name == o.granite_workflowinbox_sort_property_name &&
          granite_workflowinbox_sort_order == o.granite_workflowinbox_sort_order &&
          cq_workflow_job_retry == o.cq_workflow_job_retry &&
          cq_workflow_superuser == o.cq_workflow_superuser &&
          granite_workflow_inbox_query_size == o.granite_workflow_inbox_query_size &&
          granite_workflow_admin_user_group_filter == o.granite_workflow_admin_user_group_filter &&
          granite_workflow_enforce_workitem_assignee_permissions == o.granite_workflow_enforce_workitem_assignee_permissions &&
          granite_workflow_enforce_workflow_initiator_permissions == o.granite_workflow_enforce_workflow_initiator_permissions &&
          granite_workflow_inject_tenant_id_in_job_topics == o.granite_workflow_inject_tenant_id_in_job_topics &&
          granite_workflow_max_purge_save_threshold == o.granite_workflow_max_purge_save_threshold &&
          granite_workflow_max_purge_query_count == o.granite_workflow_max_purge_query_count
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [granite_workflowinbox_sort_property_name, granite_workflowinbox_sort_order, cq_workflow_job_retry, cq_workflow_superuser, granite_workflow_inbox_query_size, granite_workflow_admin_user_group_filter, granite_workflow_enforce_workitem_assignee_permissions, granite_workflow_enforce_workflow_initiator_permissions, granite_workflow_inject_tenant_id_in_job_topics, granite_workflow_max_purge_save_threshold, granite_workflow_max_purge_query_count].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
