=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class OrgApacheJackrabbitOakPluginsIndexLuceneLuceneIndexProviderServProperties
    attr_accessor :disabled

    attr_accessor :debug

    attr_accessor :local_index_dir

    attr_accessor :enable_open_index_async

    attr_accessor :thread_pool_size

    attr_accessor :prefetch_index_files

    attr_accessor :extracted_text_cache_size_in_mb

    attr_accessor :extracted_text_cache_expiry_in_secs

    attr_accessor :always_use_pre_extracted_cache

    attr_accessor :boolean_clause_limit

    attr_accessor :enable_hybrid_indexing

    attr_accessor :hybrid_queue_size

    attr_accessor :disable_stored_index_definition

    attr_accessor :deleted_blobs_collection_enabled

    attr_accessor :prop_index_cleaner_interval_in_secs

    attr_accessor :enable_single_blob_index_files

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'disabled' => :'disabled',
        :'debug' => :'debug',
        :'local_index_dir' => :'localIndexDir',
        :'enable_open_index_async' => :'enableOpenIndexAsync',
        :'thread_pool_size' => :'threadPoolSize',
        :'prefetch_index_files' => :'prefetchIndexFiles',
        :'extracted_text_cache_size_in_mb' => :'extractedTextCacheSizeInMB',
        :'extracted_text_cache_expiry_in_secs' => :'extractedTextCacheExpiryInSecs',
        :'always_use_pre_extracted_cache' => :'alwaysUsePreExtractedCache',
        :'boolean_clause_limit' => :'booleanClauseLimit',
        :'enable_hybrid_indexing' => :'enableHybridIndexing',
        :'hybrid_queue_size' => :'hybridQueueSize',
        :'disable_stored_index_definition' => :'disableStoredIndexDefinition',
        :'deleted_blobs_collection_enabled' => :'deletedBlobsCollectionEnabled',
        :'prop_index_cleaner_interval_in_secs' => :'propIndexCleanerIntervalInSecs',
        :'enable_single_blob_index_files' => :'enableSingleBlobIndexFiles'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'disabled' => :'ConfigNodePropertyBoolean',
        :'debug' => :'ConfigNodePropertyBoolean',
        :'local_index_dir' => :'ConfigNodePropertyString',
        :'enable_open_index_async' => :'ConfigNodePropertyBoolean',
        :'thread_pool_size' => :'ConfigNodePropertyInteger',
        :'prefetch_index_files' => :'ConfigNodePropertyBoolean',
        :'extracted_text_cache_size_in_mb' => :'ConfigNodePropertyInteger',
        :'extracted_text_cache_expiry_in_secs' => :'ConfigNodePropertyInteger',
        :'always_use_pre_extracted_cache' => :'ConfigNodePropertyBoolean',
        :'boolean_clause_limit' => :'ConfigNodePropertyInteger',
        :'enable_hybrid_indexing' => :'ConfigNodePropertyBoolean',
        :'hybrid_queue_size' => :'ConfigNodePropertyInteger',
        :'disable_stored_index_definition' => :'ConfigNodePropertyBoolean',
        :'deleted_blobs_collection_enabled' => :'ConfigNodePropertyBoolean',
        :'prop_index_cleaner_interval_in_secs' => :'ConfigNodePropertyInteger',
        :'enable_single_blob_index_files' => :'ConfigNodePropertyBoolean'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'disabled')
        self.disabled = attributes[:'disabled']
      end

      if attributes.has_key?(:'debug')
        self.debug = attributes[:'debug']
      end

      if attributes.has_key?(:'localIndexDir')
        self.local_index_dir = attributes[:'localIndexDir']
      end

      if attributes.has_key?(:'enableOpenIndexAsync')
        self.enable_open_index_async = attributes[:'enableOpenIndexAsync']
      end

      if attributes.has_key?(:'threadPoolSize')
        self.thread_pool_size = attributes[:'threadPoolSize']
      end

      if attributes.has_key?(:'prefetchIndexFiles')
        self.prefetch_index_files = attributes[:'prefetchIndexFiles']
      end

      if attributes.has_key?(:'extractedTextCacheSizeInMB')
        self.extracted_text_cache_size_in_mb = attributes[:'extractedTextCacheSizeInMB']
      end

      if attributes.has_key?(:'extractedTextCacheExpiryInSecs')
        self.extracted_text_cache_expiry_in_secs = attributes[:'extractedTextCacheExpiryInSecs']
      end

      if attributes.has_key?(:'alwaysUsePreExtractedCache')
        self.always_use_pre_extracted_cache = attributes[:'alwaysUsePreExtractedCache']
      end

      if attributes.has_key?(:'booleanClauseLimit')
        self.boolean_clause_limit = attributes[:'booleanClauseLimit']
      end

      if attributes.has_key?(:'enableHybridIndexing')
        self.enable_hybrid_indexing = attributes[:'enableHybridIndexing']
      end

      if attributes.has_key?(:'hybridQueueSize')
        self.hybrid_queue_size = attributes[:'hybridQueueSize']
      end

      if attributes.has_key?(:'disableStoredIndexDefinition')
        self.disable_stored_index_definition = attributes[:'disableStoredIndexDefinition']
      end

      if attributes.has_key?(:'deletedBlobsCollectionEnabled')
        self.deleted_blobs_collection_enabled = attributes[:'deletedBlobsCollectionEnabled']
      end

      if attributes.has_key?(:'propIndexCleanerIntervalInSecs')
        self.prop_index_cleaner_interval_in_secs = attributes[:'propIndexCleanerIntervalInSecs']
      end

      if attributes.has_key?(:'enableSingleBlobIndexFiles')
        self.enable_single_blob_index_files = attributes[:'enableSingleBlobIndexFiles']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          disabled == o.disabled &&
          debug == o.debug &&
          local_index_dir == o.local_index_dir &&
          enable_open_index_async == o.enable_open_index_async &&
          thread_pool_size == o.thread_pool_size &&
          prefetch_index_files == o.prefetch_index_files &&
          extracted_text_cache_size_in_mb == o.extracted_text_cache_size_in_mb &&
          extracted_text_cache_expiry_in_secs == o.extracted_text_cache_expiry_in_secs &&
          always_use_pre_extracted_cache == o.always_use_pre_extracted_cache &&
          boolean_clause_limit == o.boolean_clause_limit &&
          enable_hybrid_indexing == o.enable_hybrid_indexing &&
          hybrid_queue_size == o.hybrid_queue_size &&
          disable_stored_index_definition == o.disable_stored_index_definition &&
          deleted_blobs_collection_enabled == o.deleted_blobs_collection_enabled &&
          prop_index_cleaner_interval_in_secs == o.prop_index_cleaner_interval_in_secs &&
          enable_single_blob_index_files == o.enable_single_blob_index_files
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [disabled, debug, local_index_dir, enable_open_index_async, thread_pool_size, prefetch_index_files, extracted_text_cache_size_in_mb, extracted_text_cache_expiry_in_secs, always_use_pre_extracted_cache, boolean_clause_limit, enable_hybrid_indexing, hybrid_queue_size, disable_stored_index_definition, deleted_blobs_collection_enabled, prop_index_cleaner_interval_in_secs, enable_single_blob_index_files].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
