=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class OrgApacheJackrabbitOakPluginsIndexSolrOsgiOakSolrConfigurationProperties
    attr_accessor :path_desc_field

    attr_accessor :path_child_field

    attr_accessor :path_parent_field

    attr_accessor :path_exact_field

    attr_accessor :catch_all_field

    attr_accessor :collapsed_path_field

    attr_accessor :path_depth_field

    attr_accessor :commit_policy

    attr_accessor :rows

    attr_accessor :path_restrictions

    attr_accessor :property_restrictions

    attr_accessor :primarytypes_restrictions

    attr_accessor :ignored_properties

    attr_accessor :used_properties

    attr_accessor :type_mappings

    attr_accessor :property_mappings

    attr_accessor :collapse_jcrcontent_nodes

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'path_desc_field' => :'path.desc.field',
        :'path_child_field' => :'path.child.field',
        :'path_parent_field' => :'path.parent.field',
        :'path_exact_field' => :'path.exact.field',
        :'catch_all_field' => :'catch.all.field',
        :'collapsed_path_field' => :'collapsed.path.field',
        :'path_depth_field' => :'path.depth.field',
        :'commit_policy' => :'commit.policy',
        :'rows' => :'rows',
        :'path_restrictions' => :'path.restrictions',
        :'property_restrictions' => :'property.restrictions',
        :'primarytypes_restrictions' => :'primarytypes.restrictions',
        :'ignored_properties' => :'ignored.properties',
        :'used_properties' => :'used.properties',
        :'type_mappings' => :'type.mappings',
        :'property_mappings' => :'property.mappings',
        :'collapse_jcrcontent_nodes' => :'collapse.jcrcontent.nodes'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'path_desc_field' => :'ConfigNodePropertyString',
        :'path_child_field' => :'ConfigNodePropertyString',
        :'path_parent_field' => :'ConfigNodePropertyString',
        :'path_exact_field' => :'ConfigNodePropertyString',
        :'catch_all_field' => :'ConfigNodePropertyString',
        :'collapsed_path_field' => :'ConfigNodePropertyString',
        :'path_depth_field' => :'ConfigNodePropertyString',
        :'commit_policy' => :'ConfigNodePropertyDropDown',
        :'rows' => :'ConfigNodePropertyInteger',
        :'path_restrictions' => :'ConfigNodePropertyBoolean',
        :'property_restrictions' => :'ConfigNodePropertyBoolean',
        :'primarytypes_restrictions' => :'ConfigNodePropertyBoolean',
        :'ignored_properties' => :'ConfigNodePropertyArray',
        :'used_properties' => :'ConfigNodePropertyArray',
        :'type_mappings' => :'ConfigNodePropertyArray',
        :'property_mappings' => :'ConfigNodePropertyArray',
        :'collapse_jcrcontent_nodes' => :'ConfigNodePropertyBoolean'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'path.desc.field')
        self.path_desc_field = attributes[:'path.desc.field']
      end

      if attributes.has_key?(:'path.child.field')
        self.path_child_field = attributes[:'path.child.field']
      end

      if attributes.has_key?(:'path.parent.field')
        self.path_parent_field = attributes[:'path.parent.field']
      end

      if attributes.has_key?(:'path.exact.field')
        self.path_exact_field = attributes[:'path.exact.field']
      end

      if attributes.has_key?(:'catch.all.field')
        self.catch_all_field = attributes[:'catch.all.field']
      end

      if attributes.has_key?(:'collapsed.path.field')
        self.collapsed_path_field = attributes[:'collapsed.path.field']
      end

      if attributes.has_key?(:'path.depth.field')
        self.path_depth_field = attributes[:'path.depth.field']
      end

      if attributes.has_key?(:'commit.policy')
        self.commit_policy = attributes[:'commit.policy']
      end

      if attributes.has_key?(:'rows')
        self.rows = attributes[:'rows']
      end

      if attributes.has_key?(:'path.restrictions')
        self.path_restrictions = attributes[:'path.restrictions']
      end

      if attributes.has_key?(:'property.restrictions')
        self.property_restrictions = attributes[:'property.restrictions']
      end

      if attributes.has_key?(:'primarytypes.restrictions')
        self.primarytypes_restrictions = attributes[:'primarytypes.restrictions']
      end

      if attributes.has_key?(:'ignored.properties')
        self.ignored_properties = attributes[:'ignored.properties']
      end

      if attributes.has_key?(:'used.properties')
        self.used_properties = attributes[:'used.properties']
      end

      if attributes.has_key?(:'type.mappings')
        self.type_mappings = attributes[:'type.mappings']
      end

      if attributes.has_key?(:'property.mappings')
        self.property_mappings = attributes[:'property.mappings']
      end

      if attributes.has_key?(:'collapse.jcrcontent.nodes')
        self.collapse_jcrcontent_nodes = attributes[:'collapse.jcrcontent.nodes']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          path_desc_field == o.path_desc_field &&
          path_child_field == o.path_child_field &&
          path_parent_field == o.path_parent_field &&
          path_exact_field == o.path_exact_field &&
          catch_all_field == o.catch_all_field &&
          collapsed_path_field == o.collapsed_path_field &&
          path_depth_field == o.path_depth_field &&
          commit_policy == o.commit_policy &&
          rows == o.rows &&
          path_restrictions == o.path_restrictions &&
          property_restrictions == o.property_restrictions &&
          primarytypes_restrictions == o.primarytypes_restrictions &&
          ignored_properties == o.ignored_properties &&
          used_properties == o.used_properties &&
          type_mappings == o.type_mappings &&
          property_mappings == o.property_mappings &&
          collapse_jcrcontent_nodes == o.collapse_jcrcontent_nodes
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [path_desc_field, path_child_field, path_parent_field, path_exact_field, catch_all_field, collapsed_path_field, path_depth_field, commit_policy, rows, path_restrictions, property_restrictions, primarytypes_restrictions, ignored_properties, used_properties, type_mappings, property_mappings, collapse_jcrcontent_nodes].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
