=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class OrgApacheJackrabbitOakSpiSecurityAuthenticationExternalImplDeProperties
    attr_accessor :handler_name

    attr_accessor :user_expiration_time

    attr_accessor :user_auto_membership

    attr_accessor :user_property_mapping

    attr_accessor :user_path_prefix

    attr_accessor :user_membership_exp_time

    attr_accessor :user_membership_nesting_depth

    attr_accessor :user_dynamic_membership

    attr_accessor :user_disable_missing

    attr_accessor :group_expiration_time

    attr_accessor :group_auto_membership

    attr_accessor :group_property_mapping

    attr_accessor :group_path_prefix

    attr_accessor :enable_rfc7613_usercase_mapped_profile

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'handler_name' => :'handler.name',
        :'user_expiration_time' => :'user.expirationTime',
        :'user_auto_membership' => :'user.autoMembership',
        :'user_property_mapping' => :'user.propertyMapping',
        :'user_path_prefix' => :'user.pathPrefix',
        :'user_membership_exp_time' => :'user.membershipExpTime',
        :'user_membership_nesting_depth' => :'user.membershipNestingDepth',
        :'user_dynamic_membership' => :'user.dynamicMembership',
        :'user_disable_missing' => :'user.disableMissing',
        :'group_expiration_time' => :'group.expirationTime',
        :'group_auto_membership' => :'group.autoMembership',
        :'group_property_mapping' => :'group.propertyMapping',
        :'group_path_prefix' => :'group.pathPrefix',
        :'enable_rfc7613_usercase_mapped_profile' => :'enableRFC7613UsercaseMappedProfile'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'handler_name' => :'ConfigNodePropertyString',
        :'user_expiration_time' => :'ConfigNodePropertyString',
        :'user_auto_membership' => :'ConfigNodePropertyArray',
        :'user_property_mapping' => :'ConfigNodePropertyArray',
        :'user_path_prefix' => :'ConfigNodePropertyString',
        :'user_membership_exp_time' => :'ConfigNodePropertyString',
        :'user_membership_nesting_depth' => :'ConfigNodePropertyInteger',
        :'user_dynamic_membership' => :'ConfigNodePropertyBoolean',
        :'user_disable_missing' => :'ConfigNodePropertyBoolean',
        :'group_expiration_time' => :'ConfigNodePropertyString',
        :'group_auto_membership' => :'ConfigNodePropertyArray',
        :'group_property_mapping' => :'ConfigNodePropertyArray',
        :'group_path_prefix' => :'ConfigNodePropertyString',
        :'enable_rfc7613_usercase_mapped_profile' => :'ConfigNodePropertyBoolean'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'handler.name')
        self.handler_name = attributes[:'handler.name']
      end

      if attributes.has_key?(:'user.expirationTime')
        self.user_expiration_time = attributes[:'user.expirationTime']
      end

      if attributes.has_key?(:'user.autoMembership')
        self.user_auto_membership = attributes[:'user.autoMembership']
      end

      if attributes.has_key?(:'user.propertyMapping')
        self.user_property_mapping = attributes[:'user.propertyMapping']
      end

      if attributes.has_key?(:'user.pathPrefix')
        self.user_path_prefix = attributes[:'user.pathPrefix']
      end

      if attributes.has_key?(:'user.membershipExpTime')
        self.user_membership_exp_time = attributes[:'user.membershipExpTime']
      end

      if attributes.has_key?(:'user.membershipNestingDepth')
        self.user_membership_nesting_depth = attributes[:'user.membershipNestingDepth']
      end

      if attributes.has_key?(:'user.dynamicMembership')
        self.user_dynamic_membership = attributes[:'user.dynamicMembership']
      end

      if attributes.has_key?(:'user.disableMissing')
        self.user_disable_missing = attributes[:'user.disableMissing']
      end

      if attributes.has_key?(:'group.expirationTime')
        self.group_expiration_time = attributes[:'group.expirationTime']
      end

      if attributes.has_key?(:'group.autoMembership')
        self.group_auto_membership = attributes[:'group.autoMembership']
      end

      if attributes.has_key?(:'group.propertyMapping')
        self.group_property_mapping = attributes[:'group.propertyMapping']
      end

      if attributes.has_key?(:'group.pathPrefix')
        self.group_path_prefix = attributes[:'group.pathPrefix']
      end

      if attributes.has_key?(:'enableRFC7613UsercaseMappedProfile')
        self.enable_rfc7613_usercase_mapped_profile = attributes[:'enableRFC7613UsercaseMappedProfile']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          handler_name == o.handler_name &&
          user_expiration_time == o.user_expiration_time &&
          user_auto_membership == o.user_auto_membership &&
          user_property_mapping == o.user_property_mapping &&
          user_path_prefix == o.user_path_prefix &&
          user_membership_exp_time == o.user_membership_exp_time &&
          user_membership_nesting_depth == o.user_membership_nesting_depth &&
          user_dynamic_membership == o.user_dynamic_membership &&
          user_disable_missing == o.user_disable_missing &&
          group_expiration_time == o.group_expiration_time &&
          group_auto_membership == o.group_auto_membership &&
          group_property_mapping == o.group_property_mapping &&
          group_path_prefix == o.group_path_prefix &&
          enable_rfc7613_usercase_mapped_profile == o.enable_rfc7613_usercase_mapped_profile
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [handler_name, user_expiration_time, user_auto_membership, user_property_mapping, user_path_prefix, user_membership_exp_time, user_membership_nesting_depth, user_dynamic_membership, user_disable_missing, group_expiration_time, group_auto_membership, group_property_mapping, group_path_prefix, enable_rfc7613_usercase_mapped_profile].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
