=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class OrgApacheSlingEventJobsQueueConfigurationProperties
    attr_accessor :queue_name

    attr_accessor :queue_topics

    attr_accessor :queue_type

    attr_accessor :queue_priority

    attr_accessor :queue_retries

    attr_accessor :queue_retrydelay

    attr_accessor :queue_maxparallel

    attr_accessor :queue_keep_jobs

    attr_accessor :queue_prefer_run_on_creation_instance

    attr_accessor :queue_thread_pool_size

    attr_accessor :service_ranking

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'queue_name' => :'queue.name',
        :'queue_topics' => :'queue.topics',
        :'queue_type' => :'queue.type',
        :'queue_priority' => :'queue.priority',
        :'queue_retries' => :'queue.retries',
        :'queue_retrydelay' => :'queue.retrydelay',
        :'queue_maxparallel' => :'queue.maxparallel',
        :'queue_keep_jobs' => :'queue.keepJobs',
        :'queue_prefer_run_on_creation_instance' => :'queue.preferRunOnCreationInstance',
        :'queue_thread_pool_size' => :'queue.threadPoolSize',
        :'service_ranking' => :'service.ranking'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'queue_name' => :'ConfigNodePropertyString',
        :'queue_topics' => :'ConfigNodePropertyArray',
        :'queue_type' => :'ConfigNodePropertyDropDown',
        :'queue_priority' => :'ConfigNodePropertyDropDown',
        :'queue_retries' => :'ConfigNodePropertyInteger',
        :'queue_retrydelay' => :'ConfigNodePropertyInteger',
        :'queue_maxparallel' => :'ConfigNodePropertyFloat',
        :'queue_keep_jobs' => :'ConfigNodePropertyBoolean',
        :'queue_prefer_run_on_creation_instance' => :'ConfigNodePropertyBoolean',
        :'queue_thread_pool_size' => :'ConfigNodePropertyInteger',
        :'service_ranking' => :'ConfigNodePropertyInteger'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'queue.name')
        self.queue_name = attributes[:'queue.name']
      end

      if attributes.has_key?(:'queue.topics')
        self.queue_topics = attributes[:'queue.topics']
      end

      if attributes.has_key?(:'queue.type')
        self.queue_type = attributes[:'queue.type']
      end

      if attributes.has_key?(:'queue.priority')
        self.queue_priority = attributes[:'queue.priority']
      end

      if attributes.has_key?(:'queue.retries')
        self.queue_retries = attributes[:'queue.retries']
      end

      if attributes.has_key?(:'queue.retrydelay')
        self.queue_retrydelay = attributes[:'queue.retrydelay']
      end

      if attributes.has_key?(:'queue.maxparallel')
        self.queue_maxparallel = attributes[:'queue.maxparallel']
      end

      if attributes.has_key?(:'queue.keepJobs')
        self.queue_keep_jobs = attributes[:'queue.keepJobs']
      end

      if attributes.has_key?(:'queue.preferRunOnCreationInstance')
        self.queue_prefer_run_on_creation_instance = attributes[:'queue.preferRunOnCreationInstance']
      end

      if attributes.has_key?(:'queue.threadPoolSize')
        self.queue_thread_pool_size = attributes[:'queue.threadPoolSize']
      end

      if attributes.has_key?(:'service.ranking')
        self.service_ranking = attributes[:'service.ranking']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          queue_name == o.queue_name &&
          queue_topics == o.queue_topics &&
          queue_type == o.queue_type &&
          queue_priority == o.queue_priority &&
          queue_retries == o.queue_retries &&
          queue_retrydelay == o.queue_retrydelay &&
          queue_maxparallel == o.queue_maxparallel &&
          queue_keep_jobs == o.queue_keep_jobs &&
          queue_prefer_run_on_creation_instance == o.queue_prefer_run_on_creation_instance &&
          queue_thread_pool_size == o.queue_thread_pool_size &&
          service_ranking == o.service_ranking
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [queue_name, queue_topics, queue_type, queue_priority, queue_retries, queue_retrydelay, queue_maxparallel, queue_keep_jobs, queue_prefer_run_on_creation_instance, queue_thread_pool_size, service_ranking].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
