=begin
#Adobe Experience Manager OSGI config (AEM) API

#Swagger AEM OSGI is an OpenAPI specification for Adobe Experience Manager (AEM) OSGI Configurations API

OpenAPI spec version: 1.0.0-pre.0
Contact: opensource@shinesolutions.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.2.1-SNAPSHOT

=end

require 'date'

module SwaggerAemOsgiClient
  class OrgApacheSlingServletsPostImplSlingPostServletProperties
    attr_accessor :servlet_post_date_formats

    attr_accessor :servlet_post_node_name_hints

    attr_accessor :servlet_post_node_name_max_length

    attr_accessor :servlet_post_checkin_new_versionable_nodes

    attr_accessor :servlet_post_auto_checkout

    attr_accessor :servlet_post_auto_checkin

    attr_accessor :servlet_post_ignore_pattern

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'servlet_post_date_formats' => :'servlet.post.dateFormats',
        :'servlet_post_node_name_hints' => :'servlet.post.nodeNameHints',
        :'servlet_post_node_name_max_length' => :'servlet.post.nodeNameMaxLength',
        :'servlet_post_checkin_new_versionable_nodes' => :'servlet.post.checkinNewVersionableNodes',
        :'servlet_post_auto_checkout' => :'servlet.post.autoCheckout',
        :'servlet_post_auto_checkin' => :'servlet.post.autoCheckin',
        :'servlet_post_ignore_pattern' => :'servlet.post.ignorePattern'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'servlet_post_date_formats' => :'ConfigNodePropertyArray',
        :'servlet_post_node_name_hints' => :'ConfigNodePropertyArray',
        :'servlet_post_node_name_max_length' => :'ConfigNodePropertyInteger',
        :'servlet_post_checkin_new_versionable_nodes' => :'ConfigNodePropertyBoolean',
        :'servlet_post_auto_checkout' => :'ConfigNodePropertyBoolean',
        :'servlet_post_auto_checkin' => :'ConfigNodePropertyBoolean',
        :'servlet_post_ignore_pattern' => :'ConfigNodePropertyString'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'servlet.post.dateFormats')
        self.servlet_post_date_formats = attributes[:'servlet.post.dateFormats']
      end

      if attributes.has_key?(:'servlet.post.nodeNameHints')
        self.servlet_post_node_name_hints = attributes[:'servlet.post.nodeNameHints']
      end

      if attributes.has_key?(:'servlet.post.nodeNameMaxLength')
        self.servlet_post_node_name_max_length = attributes[:'servlet.post.nodeNameMaxLength']
      end

      if attributes.has_key?(:'servlet.post.checkinNewVersionableNodes')
        self.servlet_post_checkin_new_versionable_nodes = attributes[:'servlet.post.checkinNewVersionableNodes']
      end

      if attributes.has_key?(:'servlet.post.autoCheckout')
        self.servlet_post_auto_checkout = attributes[:'servlet.post.autoCheckout']
      end

      if attributes.has_key?(:'servlet.post.autoCheckin')
        self.servlet_post_auto_checkin = attributes[:'servlet.post.autoCheckin']
      end

      if attributes.has_key?(:'servlet.post.ignorePattern')
        self.servlet_post_ignore_pattern = attributes[:'servlet.post.ignorePattern']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          servlet_post_date_formats == o.servlet_post_date_formats &&
          servlet_post_node_name_hints == o.servlet_post_node_name_hints &&
          servlet_post_node_name_max_length == o.servlet_post_node_name_max_length &&
          servlet_post_checkin_new_versionable_nodes == o.servlet_post_checkin_new_versionable_nodes &&
          servlet_post_auto_checkout == o.servlet_post_auto_checkout &&
          servlet_post_auto_checkin == o.servlet_post_auto_checkin &&
          servlet_post_ignore_pattern == o.servlet_post_ignore_pattern
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [servlet_post_date_formats, servlet_post_node_name_hints, servlet_post_node_name_max_length, servlet_post_checkin_new_versionable_nodes, servlet_post_auto_checkout, servlet_post_auto_checkin, servlet_post_ignore_pattern].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerAemOsgiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
